package com.loafle.overflow.module.discovery.model;

import org.codehaus.jackson.annotate.JsonIgnore;

import javax.persistence.*;
import java.util.Date;
import java.util.List;

/**
 * Created by root on 17. 6. 4.
 */
@Entity
public class Host {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private long id;

    @Column(name = "IP",nullable = false)
    private long ip;

    @Column(name = "MAC",nullable = false)
    private long mac;

    @ManyToOne
    @JoinColumn(name = "ZONE_ID", nullable = false)
    @JsonIgnore
    private Zone zone;

    public Zone getZone() {
        return zone;
    }

    public void setZone(Zone zone) {
        this.zone = zone;
    }



    @OneToMany(mappedBy = "host",cascade = CascadeType.ALL)
    private List<Port> ports;

    public List<Port> getPorts() {
        return ports;
    }

    public void setPorts(List<Port> ports) {
        this.ports = ports;
    }

    @Column(name = "CREATE_DATE", columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", nullable = false, insertable = false, updatable = false)
    private Date createDate;

    @Column(name = "UPDATE_DATE", columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", nullable = false, insertable = false)
    private Date updateDate;


    public Host(){}

    public Host(long ip, long mac){
        this.ip = ip;
        this.mac = mac;
    }

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public long getIp() {
        return ip;
    }

    public void setIp(long ip) {
        this.ip = ip;
    }

    public long getMac() {
        return mac;
    }

    public void setMac(long mac) {
        this.mac = mac;
    }

    public Date getCreateDate() {
        return createDate;
    }

    public void setCreateDate(Date createDate) {
        this.createDate = createDate;
    }

    public Date getUpdateDate() {
        return updateDate;
    }

    public void setUpdateDate(Date updateDate) {
        this.updateDate = updateDate;
    }

    public void mappingChildren(Zone discoveryZone) {
        this.setZone(discoveryZone);

        List<Port> ports = this.getPorts();
        if (ports != null) {
            for (int j =0 ; j < ports.size() ; ++j) {
                ports.get(j).mappingChildren(this);
            }
        }
    }
}
