package com.loafle.overflow.module.infra;

import javax.persistence.*;
import java.sql.Timestamp;

/**
 * Created by root on 17. 6. 22.
 */
@Entity
@Table(name = "TBL_INFRA_OS_PORT", schema = "public", catalog = "postgres")
public class InfraOsPort {
    private long id;
    private long osId;
    private Timestamp createDate;
    private Integer port;
    private String portType;
    private Integer vendorId;
    private boolean tlsType;

    @Id
    @Column(name = "ID", nullable = false)
    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    @Basic
    @Column(name = "OS_ID", nullable = false)
    public long getOsId() {
        return osId;
    }

    public void setOsId(long osId) {
        this.osId = osId;
    }

    @Basic
    @Column(name = "CREATE_DATE", nullable = true)
    public Timestamp getCreateDate() {
        return createDate;
    }

    public void setCreateDate(Timestamp createDate) {
        this.createDate = createDate;
    }

    @Basic
    @Column(name = "PORT", nullable = true)
    public Integer getPort() {
        return port;
    }

    public void setPort(Integer port) {
        this.port = port;
    }

    @Basic
    @Column(name = "PORT_TYPE", nullable = false, length = -1)
    public String getPortType() {
        return portType;
    }

    public void setPortType(String portType) {
        this.portType = portType;
    }

    @Basic
    @Column(name = "VENDOR_ID", nullable = true)
    public Integer getVendorId() {
        return vendorId;
    }

    public void setVendorId(Integer vendorId) {
        this.vendorId = vendorId;
    }

    @Basic
    @Column(name = "TLS_TYPE", nullable = false)
    public boolean isTlsType() {
        return tlsType;
    }

    public void setTlsType(boolean tlsType) {
        this.tlsType = tlsType;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        InfraOsPort that = (InfraOsPort) o;

        if (id != that.id) return false;
        if (osId != that.osId) return false;
        if (tlsType != that.tlsType) return false;
        if (createDate != null ? !createDate.equals(that.createDate) : that.createDate != null) return false;
        if (port != null ? !port.equals(that.port) : that.port != null) return false;
        if (portType != null ? !portType.equals(that.portType) : that.portType != null) return false;
        if (vendorId != null ? !vendorId.equals(that.vendorId) : that.vendorId != null) return false;

        return true;
    }

    @Override
    public int hashCode() {
        int result = (int) (id ^ (id >>> 32));
        result = 31 * result + (int) (osId ^ (osId >>> 32));
        result = 31 * result + (createDate != null ? createDate.hashCode() : 0);
        result = 31 * result + (port != null ? port.hashCode() : 0);
        result = 31 * result + (portType != null ? portType.hashCode() : 0);
        result = 31 * result + (vendorId != null ? vendorId.hashCode() : 0);
        result = 31 * result + (tlsType ? 1 : 0);
        return result;
    }
}
