package com.loafle.overflow.module.infra;

import javax.persistence.*;
import java.sql.Timestamp;

/**
 * Created by root on 17. 6. 22.
 */
@Entity
@Table(name = "TBL_INFRA_SERVICE", schema = "public", catalog = "postgres")
public class InfraService {
    private long id;
    private long hostId;
    private String portType;
    private Integer port;
    private int vendorId;
    private Timestamp createDate;
    private boolean tlsType;

    @Id
    @Column(name = "ID", nullable = false)
    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    @Basic
    @Column(name = "HOST_ID", nullable = false)
    public long getHostId() {
        return hostId;
    }

    public void setHostId(long hostId) {
        this.hostId = hostId;
    }

    @Basic
    @Column(name = "PORT_TYPE", nullable = false, length = -1)
    public String getPortType() {
        return portType;
    }

    public void setPortType(String portType) {
        this.portType = portType;
    }

    @Basic
    @Column(name = "PORT", nullable = true)
    public Integer getPort() {
        return port;
    }

    public void setPort(Integer port) {
        this.port = port;
    }

    @Basic
    @Column(name = "VENDOR_ID", nullable = false)
    public int getVendorId() {
        return vendorId;
    }

    public void setVendorId(int vendorId) {
        this.vendorId = vendorId;
    }

    @Basic
    @Column(name = "CREATE_DATE", nullable = false)
    public Timestamp getCreateDate() {
        return createDate;
    }

    public void setCreateDate(Timestamp createDate) {
        this.createDate = createDate;
    }

    @Basic
    @Column(name = "TLS_TYPE", nullable = false)
    public boolean isTlsType() {
        return tlsType;
    }

    public void setTlsType(boolean tlsType) {
        this.tlsType = tlsType;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        InfraService that = (InfraService) o;

        if (id != that.id) return false;
        if (hostId != that.hostId) return false;
        if (vendorId != that.vendorId) return false;
        if (tlsType != that.tlsType) return false;
        if (portType != null ? !portType.equals(that.portType) : that.portType != null) return false;
        if (port != null ? !port.equals(that.port) : that.port != null) return false;
        if (createDate != null ? !createDate.equals(that.createDate) : that.createDate != null) return false;

        return true;
    }

    @Override
    public int hashCode() {
        int result = (int) (id ^ (id >>> 32));
        result = 31 * result + (int) (hostId ^ (hostId >>> 32));
        result = 31 * result + (portType != null ? portType.hashCode() : 0);
        result = 31 * result + (port != null ? port.hashCode() : 0);
        result = 31 * result + vendorId;
        result = 31 * result + (createDate != null ? createDate.hashCode() : 0);
        result = 31 * result + (tlsType ? 1 : 0);
        return result;
    }
}
