package com.loafle.overflow.module.noauthagent.model;

import com.loafle.overflow.module.noauthagent.type.AuthType;

import javax.persistence.*;
import java.util.Date;

/**
 * Created by root on 17. 5. 30.
 */
@Entity
@Table(name = "NOAUTH_AGENT")
public class NoAuthAgent {

    @Id
    @GeneratedValue(strategy= GenerationType.IDENTITY)
    private Long id;

    @Column(name="TEMP_KEY", unique=true, nullable=false)
    private String tempKey;

    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="DATE", nullable=false)
    private Date date;

    @Column(name="API_KEY", unique = true, nullable=false)
    private String apiKey;

    @Column(name="AUTH_STATUS", nullable=false)
    @Enumerated(EnumType.STRING)
    private AuthType authStatus;

    @Column(name="LOCAL_IP", nullable=false)
    private long localIP;

    @Column(name="HOST_NAME")
    private String hostName;


    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getTempKey() {
        return tempKey;
    }

    public void setTempKey(String tempKey) {
        this.tempKey = tempKey;
    }

    public Date getDate() {
        return date;
    }

    public void setDate(Date date) {
        this.date = date;
    }

    public String getApiKey() {
        return apiKey;
    }

    public void setApiKey(String apiKey) {
        this.apiKey = apiKey;
    }

    public AuthType getAuthStatus() {
        return authStatus;
    }

    public void setAuthStatus(AuthType authStatus) {
        this.authStatus = authStatus;
    }

    public long getLocalIP() {
        return localIP;
    }

    public void setLocalIP(long localIP) {
        this.localIP = localIP;
    }

    public String getHostName() {
        return hostName;
    }

    public void setHostName(String hostName) {
        this.hostName = hostName;
    }
}
