package com.loafle.overflow.module.sensor.model;

import javax.persistence.*;
import java.sql.Timestamp;

/**
 * Created by root on 17. 6. 22.
 */
@Entity
@Table(name = "TBL_SENSOR", schema = "public", catalog = "postgres")
public class Sensor {
    private long id;
    private Timestamp createDate;
    private String desc;
    private String status;
    private long targetId;
    private short crawlerId;
    private String crawelrInputItems;

    @Id
    @Column(name = "ID", nullable = false)
    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    @Basic
    @Column(name = "CREATE_DATE", nullable = false)
    public Timestamp getCreateDate() {
        return createDate;
    }

    public void setCreateDate(Timestamp createDate) {
        this.createDate = createDate;
    }

    @Basic
    @Column(name = "DESC", nullable = true, length = 50)
    public String getDesc() {
        return desc;
    }

    public void setDesc(String desc) {
        this.desc = desc;
    }

    @Basic
    @Column(name = "STATUS", nullable = true, length = 50)
    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    @Basic
    @Column(name = "TARGET_ID", nullable = false)
    public long getTargetId() {
        return targetId;
    }

    public void setTargetId(long targetId) {
        this.targetId = targetId;
    }

    @Basic
    @Column(name = "CRAWLER_ID", nullable = false)
    public short getCrawlerId() {
        return crawlerId;
    }

    public void setCrawlerId(short crawlerId) {
        this.crawlerId = crawlerId;
    }

    @Basic
    @Column(name = "CRAWELR_INPUT_ITEMS", nullable = true, length = 50)
    public String getCrawelrInputItems() {
        return crawelrInputItems;
    }

    public void setCrawelrInputItems(String crawelrInputItems) {
        this.crawelrInputItems = crawelrInputItems;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        Sensor tblSensor = (Sensor) o;

        if (id != tblSensor.id) return false;
        if (targetId != tblSensor.targetId) return false;
        if (crawlerId != tblSensor.crawlerId) return false;
        if (createDate != null ? !createDate.equals(tblSensor.createDate) : tblSensor.createDate != null) return false;
        if (desc != null ? !desc.equals(tblSensor.desc) : tblSensor.desc != null) return false;
        if (status != null ? !status.equals(tblSensor.status) : tblSensor.status != null) return false;
        if (crawelrInputItems != null ? !crawelrInputItems.equals(tblSensor.crawelrInputItems) : tblSensor.crawelrInputItems != null)
            return false;

        return true;
    }

    @Override
    public int hashCode() {
        int result = (int) (id ^ (id >>> 32));
        result = 31 * result + (createDate != null ? createDate.hashCode() : 0);
        result = 31 * result + (desc != null ? desc.hashCode() : 0);
        result = 31 * result + (status != null ? status.hashCode() : 0);
        result = 31 * result + (int) (targetId ^ (targetId >>> 32));
        result = 31 * result + (int) crawlerId;
        result = 31 * result + (crawelrInputItems != null ? crawelrInputItems.hashCode() : 0);
        return result;
    }
}
